; @com.wudsn.ide.asm.mainsourcefile=agd.asm
;******************************************************************
                        ORG $2000

                        jsr main_init

main                    ldy game_mode
                        lda jump_table_lo,y
                        sta jump_vector+1
                        lda jump_table_hi,y
                        sta jump_vector+2
jump_vector             jsr $ffff
                        jmp main

title_screen            
                        lda render_done
                        bne skip_rendering
                        
                        ;jsr setup_screen
                        
                        jsr draw_sprites
                        inc STEP
                        
;infinity                beq infinity
                        
                        lda #1
                        sta render_done
skip_rendering
@                       lda frame_start
                        beq @-
                        lda #0
                        sta frame_start
                        
                        jsr readjoy
                        lda joy1fire
                        bmi @+
                        ;Do something on fire button press
@                       lda joy1down
                        bmi @+
                        ;JOY DOWN
                        dec num_of_sprites
                        lda num_of_sprites
                        cmp #$7
                        bne @+
                        inc num_of_sprites
@                       lda joy1up
                        bmi @+
                        ;JOY UP
                        inc num_of_sprites
                        bne @+
                        dec num_of_sprites
@


                        rts

main_game
@                       lda frame_start
                        beq @-
                        lda #0
                        sta frame_start
                        jsr readjoy
                        lda joy1down
                        bmi @+
                        ;JOY DOWN
                        dec num_of_sprites
@                       lda joy1up
                        bmi @+
                        ;JOY UP
                        inc num_of_sprites
@                       lda joy1right
                        bmi @+
                        ;JOY RIGHT
                        ;inc x2
                        ;lda x2
                        ;sta HPOSP2
@                       lda joy1left
                        bmi @+
                        ;JOY LEFT
                        ;dec x2
                        ;lda x2
                        ;sta HPOSP2
@
                        lda joy1fire
                        bmi @+
                        ;JOY FIRE PRESSED
                        lda #$FF
                        sta COLBK
@
                        rts

jump_table_lo           .byte <title_screen,<main_game
jump_table_hi           .byte >title_screen,>main_game

TITLEGAME               equ 0

SCREENBUFFER            .byte 0
DLISTHI                 .byte 0

game_mode               .byte 0
dlist_ready             .byte 0
dlist_hi                .byte 0
dlist_lo                .byte 0
frame_start             .byte 0
render_done             .byte 0

rand24_table    DTA 0,0,2,2,3,4,5,5
                DTA 6,7,7,8,9,9,10,11
                DTA 12,13,13,14,15,15,16,17
                DTA 18,18,19,20,21,22,23,23

rand5_table     DTA 0,0,0,1,1,1,2,2
                DTA 2,2,3,3,3,4,4,4

rand21_table    DTA 0,0,2,2,3,4,5,5
                DTA 6,7,7,8,9,9,10,10
                DTA 11,11,12,13,13,14,15,15
                DTA 16,17,17,18,18,19,20,20

rand19_table    DTA 0,1,1,2,3,3,4,4
                DTA 5,6,6,7,8,8,9,10
                DTA 10,11,11,12,13,13,14,15
                DTA 15,16,16,17,18,18,19,19
                
gtiacolors_table
                DTA 0,$11,$22,$33,$88
                DTA 0,$11,$44,$55,$88
                DTA 0,$11,$66,$77,$88
                DTA 0

.align
screen_table_lo
:SCREEN_HEIGHT          DTA l(BITMAPSCREEN+256*#)

.align
screen_table_hi
:SCREEN_HEIGHT          DTA h(BITMAPSCREEN+256*#)

nibble_mask_table
:SCREEN_WIDTH           DTA $0F,$F0

nibble_color_mask_table
:SCREEN_WIDTH           DTA $F0,$0F

                        icl "memory_map"
                        icl "main_init"
                        icl "joystick"
                        icl "interrupts"
                        icl "graphics"

;***********************************************************
; DLIST IS ON FIXED POSITION - BEWARE TO NOT SCREW IT UP !!!
                        icl "dlist"
;***********************************************************