; @com.wudsn.ide.asm.mainsourcefile=agd.asm
;******************************************************************
init_graphics   lda #0
                sta PLOTAD

                sta STEP        ;just for testing sprites

                sta render_done
                
                lda #<BITMAPSCREEN
                sta AD1
                lda #>BITMAPSCREEN
                sta AD1+1
                
                lda #SCREEN_WIDTH
                sta SCREENBUFFER
                
                ldx #112
@               ldy #79
                lda #$77
@               sta (AD1),y
                dey
                bpl @-
                inc AD1+1
                dex
                bne @-1
                
                jsr init_sprites
                
                rts

;******************************************************************
;Init sprites (split sprites to paged rows and make shifted representation.
;******************************************************************
init_sprites    
                ldx #17
                
@               
.rept 16
                lda sprite_shapes+#*18,x
                sta SPRITE_DATA+#*$100,x
.endr
                
                dex
                bpl @-
                rts
;******************************************************************
; A = color (0-8)
; X = X coord (0-79)
; Y = Y coord (0-111)
;******************************************************************
flip_buffers    lda DLISTHI     ;eor old Dlist hi value with eor-const
                eor #DLISTHIEOR
                sta DLISTHI     ;remember value of Dlist hi
                sta DLISTH      ;change dlist pointer to new buffer
                
                lda SCREENBUFFER    ;eor screenbuffer value with Screen width
                eor #SCREEN_WIDTH   ;to go between 0 to SCREEN_WIDTH
                sta SCREENBUFFER
                
                rts
                
;******************************************************************
; A = color (0-8)
; X = X coord (0-79)
; Y = Y coord (0-111)
;******************************************************************
plot        and nibble_color_mask_table,x
            sta POM
            lda screen_table_hi,y
            sta PLOTAD+1
            txa
            lsr
            clc
            adc SCREENBUFFER
            tay
            lda (PLOTAD),y
            and nibble_mask_table,x
            ora POM
            sta (PLOTAD),y           
            rts

;******************************************************************
; Draw sprite
; A = sprite number (0-18 in first version)
; X = X coord (0-79)
; Y = Y coord (0-111)
;******************************************************************          
draw_sprite     sty POM
                tay
                lda tab_mult_9_plus_offset,y
                sta AD2
                
                lda #>SPRITE_DATA
                sta AD2+1
                

                lda POM                 ;add Y coord to high byte of bitmap start
                clc
                adc #>(BITMAPSCREEN)
                sta AD1+1

                lda #16
                sta counter

                txa
                lsr
                bcs draw_sprite_shifted ;skip if shifted sprite
                ;sprite is not shifted, y=3
                adc SCREENBUFFER
                sta AD1

@               ldy #3
                lda (AD2),y
                tax
                and (AD1),y
                ora ora_table,x
                sta (AD1),y
                dey
                
                lda (AD2),y
                tax
                and (AD1),y
                ora ora_table,x
                sta (AD1),y
                dey
                
                lda (AD2),y
                tax
                and (AD1),y
                ora ora_table,x
                sta (AD1),y
                dey
                
                lda (AD2),y
                tax
                and (AD1),y
                ora ora_table,x
                sta (AD1),y
                
                inc AD1+1   ;new line on screen
                inc AD2+1   ;new line of sprite
                dec counter
                bne @-
                rts
                
				
draw_sprite_shifted
                clc
                adc SCREENBUFFER
                sta AD1

                lda AD2     ;shifted sprite, move source 4 bytes
                adc #4
                sta AD2

@               ldy #4
                lda (AD2),y
                tax
                and (AD1),y
                ora ora_table,x
                sta (AD1),y
                dey
                
                lda (AD2),y
                tax
                and (AD1),y
                ora ora_table,x
                sta (AD1),y
                dey
                
                lda (AD2),y
                tax
                and (AD1),y
                ora ora_table,x
                sta (AD1),y
                dey

                lda (AD2),y
                tax
                and (AD1),y
                ora ora_table,x
                sta (AD1),y
                dey
                
                lda (AD2),y
                tax
                and (AD1),y
                ora ora_table,x
                sta (AD1),y
                
                inc AD1+1   ;new line on screen
                inc AD2+1   ;new line of sprite
                dec counter
                bne @-
                rts


;******************************************************************
; Erase sprite position
; X = X coord (0-79)
; Y = Y coord (0-111)
;******************************************************************          
erase_sprite    tya                     ;add Y coord to high byte of bitmap start
                clc
                adc #>(BITMAPSCREEN)
                sta AD1+1

                txa
                lsr
                clc
                adc SCREENBUFFER
                sta AD1
                
                ldx #16
                lda #$77
                
erase_sprite_row
                ldy #4
@               sta (AD1),y
                dey
                bpl @-
                inc AD1+1
                dex
                bne erase_sprite_row
                rts

;******************************************************************
; Draw sprites
; STEP is current offset 0-255
;******************************************************************          
sprite_counter  .byte 0

num_of_sprites  .byte 64
num_of_sprites2 .byte 0

draw_sprites    lda num_of_sprites
                lsr
                lsr
                lsr
                sta num_of_sprites2

                lda #0
                sta sprite_counter
@               lda sprite_counter
                asl
                asl
                asl
                ;asl
                ;asl
                sec
                sbc #2
                clc
                adc STEP
                tay
                ldx table_sprite_x,y
                lda table_sprite_y,y
                tay
                jsr erase_sprite
                inc sprite_counter
                lda sprite_counter
                cmp num_of_sprites2
                bne @-

                ldx #40-16
                ldy #56-32+8
                lda #1
                jsr draw_sprite
                ldx #40-8
                ldy #56-32+8
                lda #1
                jsr draw_sprite
                ldx #40-0
                ldy #56-32+8
                lda #1
                jsr draw_sprite
                ldx #40+8
                ldy #56-32+8
                lda #1
                jsr draw_sprite
                ldx #40-16
                ldy #56-16+8
                lda #1
                jsr draw_sprite
                ldx #40+8
                ldy #56-16+8
                lda #1
                jsr draw_sprite
                ldx #40-16
                ldy #56-0+8
                lda #1
                jsr draw_sprite
                ldx #40-8
                ldy #56-0+8
                lda #1
                jsr draw_sprite
                ldx #40-0
                ldy #56-0+8
                lda #1
                jsr draw_sprite
                ldx #40+8
                ldy #56-0+8
                lda #1
                jsr draw_sprite


                lda #0
                sta sprite_counter
                
@               lda sprite_counter
                asl
                asl
                asl
                ;asl
                ;asl
                clc
                adc STEP
                tay
                ldx table_sprite_x,y
                lda table_sprite_y,y
                tay
                lda sprite_counter  ;#1
                and #1
                jsr draw_sprite
                inc sprite_counter
                lda sprite_counter
                cmp num_of_sprites2
                bne @-
                rts

sprite_shapes
;RGB cube sprite                                        WALL SPRITE
                DTA $FF,$F0,$FF,$FF,$FF,$FF,$0F,$FF,$FF,$00,$00,$00,$00,$F0,$00,$00,$00,$0F
                DTA $FF,$02,$0F,$FF,$FF,$F0,$20,$FF,$FF,$08,$88,$38,$32,$F0,$88,$83,$83,$2F
                DTA $F0,$33,$20,$FF,$FF,$03,$32,$0F,$FF,$08,$33,$23,$22,$F0,$83,$32,$32,$2F
                DTA $02,$32,$21,$0F,$F0,$23,$22,$10,$FF,$08,$32,$22,$21,$F0,$83,$22,$22,$1F
                DTA $40,$22,$10,$6F,$F4,$02,$21,$06,$FF,$03,$22,$22,$10,$F0,$32,$22,$21,$0F
                DTA $54,$01,$07,$6F,$F5,$40,$10,$76,$FF,$08,$32,$22,$21,$F0,$83,$22,$22,$1F
                DTA $55,$40,$77,$6F,$F5,$54,$07,$76,$FF,$03,$21,$21,$10,$F0,$32,$12,$11,$0F
                DTA $54,$40,$76,$6F,$F5,$44,$07,$66,$FF,$02,$10,$10,$00,$F0,$21,$01,$00,$0F
                DTA $54,$40,$76,$1F,$F5,$44,$07,$61,$FF,$00,$00,$00,$00,$F0,$00,$00,$00,$0F
                DTA $44,$40,$66,$1F,$F4,$44,$06,$61,$FF,$58,$54,$08,$88,$F5,$85,$40,$88,$85
                DTA $44,$10,$66,$1F,$F4,$41,$06,$61,$FF,$45,$44,$08,$55,$F4,$54,$40,$85,$5F
                DTA $14,$10,$61,$1F,$F1,$41,$06,$11,$FF,$44,$41,$05,$44,$F4,$44,$10,$54,$4F
                DTA $01,$10,$61,$0F,$F0,$11,$06,$10,$FF,$44,$10,$08,$54,$F4,$41,$00,$85,$4F
                DTA $F0,$10,$10,$FF,$FF,$01,$01,$0F,$FF,$44,$41,$05,$44,$F4,$44,$10,$54,$4F
                DTA $FF,$00,$0F,$FF,$FF,$F0,$00,$FF,$FF,$41,$10,$04,$41,$F4,$11,$00,$44,$1F
                DTA $FF,$F0,$FF,$FF,$FF,$FF,$0F,$FF,$FF,$10,$00,$04,$10,$F1,$00,$00,$41,$0F

tab_mult_9_plus_offset
:19             DTA [#*9]+(SCREEN_WIDTH*2)

.align
shift_table_left
:256            DTA #>>4

shift_table_right
:256            DTA #<<4&255

ora_table
                DTA $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$00
                DTA $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$10
                DTA $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$20
                DTA $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$30
                DTA $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$40
                DTA $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$50
                DTA $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$60
                DTA $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$70
                DTA $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$80
                DTA $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$90
                DTA $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$A0
                DTA $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$B0
                DTA $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$C0
                DTA $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$D0
                DTA $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$E0
                DTA $00,$01,$F2,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$00


table_sprite_x
                DTA 36,38,41,43,46,48,51,53,55,57,58,60,61,62,63,63
                DTA 63,63,62,61,60,58,57,55,53,51,48,46,44,41,39,37
                DTA 36,34,33,32,31,31,31,31,32,33,34,36,38,40,42,44
                DTA 47,49,52,54,56,59,61,63,64,66,67,68,69,70,71,71
                DTA 71,71,71,70,69,68,67,66,64,63,61,59,56,54,52,49
                DTA 47,44,42,40,38,36,34,33,32,31,31,31,31,32,33,34
                DTA 35,37,39,41,44,46,48,51,53,55,57,58,60,61,62,63
                DTA 63,63,63,62,61,60,58,57,55,53,51,48,46,43,41,38
                DTA 36,33,30,28,25,23,20,18,16,14,13,11,10,9,8,8
                DTA 8,8,9,10,11,13,14,16,18,20,23,25,27,30,32,34
                DTA 35,37,38,39,40,40,40,40,39,38,37,35,33,31,29,27
                DTA 24,22,19,17,15,12,10,8,7,5,4,3,2,1,0,0
                DTA 0,0,0,1,2,3,4,5,7,8,10,12,15,17,19,22
                DTA 24,27,29,31,33,35,37,38,39,40,40,40,40,39,38,37
                DTA 36,34,32,30,27,25,23,20,18,16,14,13,11,10,9,8
                DTA 8,8,8,9,10,11,13,14,16,18,20,23,25,28,30,33

table_sprite_y
                DTA 48,48,48,49,50,51,52,54,55,57,60,62,65,67,70,72
                DTA 75,77,80,82,84,86,87,88,89,90,89,89,88,87,85,83
                DTA 81,78,76,73,69,66,63,59,56,53,49,47,44,42,39,38
                DTA 36,35,34,34,34,34,34,35,36,37,38,39,41,42,44,46
                DTA 47,49,51,53,54,56,57,58,59,60,61,61,61,61,61,60
                DTA 59,57,56,53,51,48,46,42,39,36,32,29,26,22,19,17
                DTA 14,12,10,8,7,6,6,5,6,7,8,9,11,13,15,18
                DTA 20,23,25,28,30,33,35,38,40,41,43,44,45,46,47,47
                DTA 48,47,47,46,45,44,43,41,40,38,35,33,30,28,25,23
                DTA 20,18,15,13,11,9,8,7,6,5,6,6,7,8,10,12
                DTA 14,17,19,22,26,29,32,36,39,42,46,48,51,53,56,57
                DTA 59,60,61,61,61,61,61,60,59,58,57,56,54,53,51,49
                DTA 48,46,44,42,41,39,38,37,36,35,34,34,34,34,34,35
                DTA 36,38,39,42,44,47,49,53,56,59,63,66,69,73,76,78
                DTA 81,83,85,87,88,89,89,90,89,88,87,86,84,82,80,77
                DTA 75,72,70,67,65,62,60,57,55,54,52,51,50,49,48,48
                