; @com.wudsn.ide.asm.mainsourcefile=agd.asm
;******************************************************************

main_init       sei
                jsr disable_roms
                jsr disable_irq
                jsr setup_nmi
                jsr setup_dma
                jsr setup_colors
                jsr setup_game
                jsr setup_bitmap_dlist
                jsr switch_vbi_bitmap_mode
                jsr init_graphics
                ;jsr setup_screen
                cli
                rts

disable_roms    lda PBCTL
                ora #%00000010
                sta PBCTL
                lda PORTB
                and #%01111100
                ora #%10000010
                sta PORTB
                rts

disable_irq     lda #$00
                sta IRQEN
                rts

setup_nmi       lda <vbi_handler0
                sta vbi_handler_jmp+1
                lda >vbi_handler0
                sta vbi_handler_jmp+2

                lda #<nmi_handler
                sta NMI
                lda #>nmi_handler
                sta NMI+1
                lda #%11000000
                sta NMIEN
                rts


setup_colors    
                MVA #%00000000 COLPM0           ;0 Black
                MVA #%00000010 COLPM1           ;1 Grey
                MVA #%00100100 COLPM2           ;2 Red
                MVA #%00101000 COLPM3           ;3 Light Red
                MVA #%10110100 COLPF0           ;4 Green
                MVA #%10111000 COLPF1           ;5 Light Green
                MVA #%01110100 COLPF2           ;6 Blue
                MVA #%01111000 COLPF3           ;7 Light Blue
                MVA #%00001110 COLBK            ;8 White


                rts

                ;   D-Display list enable
                ;   V-PM vertical resolution 1=one line
                ;   P-Player DMA
                ;   M-Missile DMA
                ;   WW-Width 10=40 characters
                ;   DVPMWW
setup_dma       lda #%00110010 ;DListEnable+OneLinePMResolution+PMEnable+Normal
                sta DMACTL
                lda #0
                sta CHACTL
                    ; TPM   T-trigger, P-players, M-missiles
                lda #%000       ;Disable PMs
                sta GRACTL


                ; Gt - Gtia mode 00=normal 10=9 colors
                ; M - multicolor player enable
                ; F - fifth player enable
                ; prior - priority 1=PM on top
                ; GtMFprior
                lda #%10001000
                sta GPRIOR
                rts

setup_game
                lda #0
                sta frame_start
                lda #0
                sta game_mode
                
                rts

BORDER          equ 26

setup_screen    
                lda #SCREEN_HEIGHT-BORDER
                sta POMY
                
@               lda #(SCREEN_WIDTH*2)-BORDER-6
                sta POMX
@               
                clc
                lda POMX
                adc POMY
                adc STEP
                and #$0F
                tax
                lda gtiacolors_table,x
                ldx POMX
                ldy POMY
                jsr plot
                
                dec POMX
                lda POMX
                cmp #BORDER+6
                bne @-
                dec POMY
                lda POMY
                cmp #BORDER
                bne @-1
                rts
