; @com.wudsn.ide.asm.mainsourcefile=agd.asm
;******************************************************************

PMMEMBASE       equ $5000
DLISTSTART1     equ $5900
DLISTSTART2     equ $5c00
DLISTHIEOR      equ 5       ;$5c eor $59

BITMAPSCREEN    equ $6000
SPRITE_DATA     equ $6000+80

SCREEN_WIDTH    equ 40
SCREEN_HEIGHT   equ 112 ;112

counter         EQU $C1
PLOTAD          EQU $C2
;PLOTAD+1       EQU $C3
jmp_vector      EQU $C4
;jmp_vector+1   EQU $C5

MAPXLO          EQU $C6
MAPXHI          EQU $C7
MAPYLO          EQU $C8
MAPYHI          EQU $C9
PY              EQU $CA
PX              EQU $CB
YO              EQU $CC
XO              EQU $CD
YS              EQU $CE
XS              EQU $CF
j               EQU $D0
k               EQU $D1
i               EQU $D2
randomness_shifts   EQU $D3
half_step       EQU $D4
POM6            EQU $D5
MAP_Y           EQU $D6
MAP_X           EQU $D7
STEP            EQU $D8
SCROLL_X        EQU $D9
MWP_PX          EQU $DA
MWP_PY          EQU $DB
MWP_Y           EQU $DC
MWP_X           EQU $DD
TILESZP         EQU $DE
;TILESZP+1      EQU $DF
SPRITESZP       EQU $DE     ;never used at same time as tileszp so can be same.
;SPRITESZP+1    EQU $DF
SCANLINE        EQU $E0     ;Not used anymore?
REGY            EQU $E1
REGX            EQU $E2
ACC             EQU $E3
POMY            EQU $E4
POMX            EQU $E5
YY              EQU $E6
XX              EQU $E7
POM5            EQU $E8
POM4            EQU $E9
POM3            EQU $EA
POM2            EQU $EB
POM1            EQU $EC
POM             EQU $ED
AD1             EQU $EE
;AD1+1          EQU $EF
AD2             EQU $F0
;AD2+1          EQU $F1
AD3             EQU $F2
;AD3+1          EQU $F3

COLPF0          equ $D016
COLPF1          equ $D017
COLPF2          equ $D018
COLPF3          equ $D019
COLBK           equ $D01A

CHBASE          equ $D409

STICK0          equ $D300
PORTB           equ $D301
PBCTL           equ $D303
TRIG0           equ $D010   ;FIRE BUTTON JOY 1
TRIG1           equ $D011   ;FIRE BUTTON JOY 2
NMIEN           equ $D40E
NMIST           equ $D40F
NMIRES          equ $D40F
VCOUNT          equ $D40B
WSYNC           equ $D40A
DLISTL          equ $D402
DLISTH          equ $D403
HSCROL          equ $D404
VSCROL          equ $D405

PMBASE          equ $D407   ;STARTING ADRESS PLAYER MISSILE GRAPHICS

HPOSP0          EQU $D000   ;HORIZONTAL POSITION P0
HPOSP1          EQU $D001   ;HORIZONTAL POSITION P1
HPOSP2          EQU $D002   ;HORIZONTAL POSITION P2
HPOSP3          EQU $D003   ;HORIZONTAL POSITION P3
HPOSM0          EQU $D004   ;HORIZONTAL POSITION M0
HPOSM1          EQU $D005   ;HORIZONTAL POSITION M1
HPOSM2          EQU $D006   ;HORIZONTAL POSITION M2
HPOSM3          EQU $D007   ;HORIZONTAL POSITION M3

SIZEP0          EQU $D008   ;SIZE P0
SIZEP1          EQU $D009   ;SIZE P0
SIZEP2          EQU $D00A   ;SIZE P0
SIZEP3          EQU $D00B   ;SIZE P0
SIZEM           EQU $D00C   ;SIZE M

GRAFP0          EQU $D00D
GRAFP1          EQU $D00E
GRAFP2          EQU $D00F
GRAFP3          EQU $D010
GRAFM           EQU $D011

COLPM0          EQU $D012   ;COLOR P0/M0
COLPM1          EQU $D013   ;COLOR P1/M1
COLPM2          EQU $D014   ;COLOR P2/M2
COLPM3          EQU $D015   ;COLOR P3/M3

RANDOM          EQU $D20A   ;RANDOM

IRQEN           equ $D20E
IRQST           equ $D20E

NMI             equ $FFFA
RESET           equ $FFFC
IRQ             equ $FFFE

DMACTL          equ $D400
CHACTL          equ $D401
GRACTL          equ $D01D
GPRIOR          equ $D01B

RTS_CODE        equ $60
INC_ZP_CODE     equ $E6


color_Rust          equ 7+16
color_White         equ 0+14
color_Black         equ 0
color_Red_orange    equ 7+32
color_Dark_orange   equ 7+48
color_Yellow        equ 218
color_Red           equ 7+64
color_Dark_lavender equ 7+80
color_Cobalt_blue   equ 7+96
color_Darker_blue   equ 134
color_Ultramarine   equ 7+112
color_Cyan          equ 154
color_Dark_blue     equ 7+144
color_Medium_blue   equ 7+128
color_Blue_grey     equ 7+160
color_Olive_green   equ 7+176
color_Medium_green  equ 7+192
color_Dark_green    equ 7+208
color_Orange_green  equ 7+224
color_Orange        equ 7+240
color_Black_pale    equ 2
color_Grey          equ 0+8
color_Pale_brown    equ 228
color_Blue2         equ 128+8
color_Brown_light   equ 16+12

COLOR0              equ $00
COLOR1              equ $72 ;$72 Blue
COLOR2              equ $C2 ;$C2 Green
COLOR3              equ $E2 ;$E2 Brown

STATUSCOLOR1        equ $22
STATUSCOLOR2        equ $C2
STATUSCOLOR3        equ $E2

LUMA0               equ $00
LUMA1               equ $04
LUMA2               equ $0A
LUMA3               equ $0E

LMS                 equ 64
HS                  equ 16
VS                  equ 32
MODE4               equ 4
MODE5               equ 5
MODED               equ $0D
MODEE               equ $0E
MODEF               equ $0F

BLANK1              equ $00
BLANK2              equ $10
BLANK7              equ $60
BLANK8              equ $70
DLI                 equ 128
DLISTJUMP           equ $01
DLISTENDJUMP        equ $41
PMVSIZEBIT          equ 16
